import { declare } from "@babel/helper-plugin-utils";
import syntaxDecorators from "@babel/plugin-syntax-decorators";
import { createClassFeaturePlugin, FEATURES } from "@babel/helper-create-class-features-plugin";
import legacyVisitor from "./transformer-legacy.js";
import transformer2022_03 from "./transformer-2023-01.js";
export default declare((api, options) => {
  api.assertVersion(7);
  {
    var {
      legacy
    } = options;
  }
  const {
    version
  } = options;
  if (legacy || version === "legacy") {
    return {
      name: "proposal-decorators",
      inherits: syntaxDecorators,
      visitor: legacyVisitor
    };
  } else if (version === "2021-12" || version === "2022-03" || version === "2023-01") {
    return transformer2022_03(api, options, version);
  } else {
    api.assertVersion("^7.0.2");
    return createClassFeaturePlugin({
      name: "proposal-decorators",
      api,
      feature: FEATURES.decorators,
      inherits: syntaxDecorators
    });
  }
});

//# sourceMappingURL=index.js.map
